Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 740990 - dev-dotnet/log4net: stuck on EAPI 4
Summary: dev-dotnet/log4net: stuck on EAPI 4
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: dotnet
URL:
Whiteboard:
Keywords: PMASKED
Depends on:
Blocks: EAPI4Removal
  Show dependency tree
 
Reported: 2020-09-08 04:11 UTC by Sam James
Modified: 2020-11-22 14:54 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Sam James archtester gentoo-dev Security 2020-09-08 04:11:36 UTC
Please bump to a newer EAPI (ideally 7).
Comment 1 Larry the Git Cow gentoo-dev 2020-10-24 13:57:08 UTC
The bug has been referenced in the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=6a866101af85e162d2f4ad6345a995e2dd8306b1

commit 6a866101af85e162d2f4ad6345a995e2dd8306b1
Author:     David Seifert <soap@gentoo.org>
AuthorDate: 2020-10-24 13:56:53 +0000
Commit:     David Seifert <soap@gentoo.org>
CommitDate: 2020-10-24 13:56:53 +0000

    package.mask: Last rite dev-dotnet/* EAPI 4 ebuilds
    
    Bug: https://bugs.gentoo.org/681194
    Bug: https://bugs.gentoo.org/722256
    Bug: https://bugs.gentoo.org/740986
    Bug: https://bugs.gentoo.org/740988
    Bug: https://bugs.gentoo.org/740990
    Signed-off-by: David Seifert <soap@gentoo.org>

 profiles/package.mask | 8 ++++++++
 1 file changed, 8 insertions(+)
Comment 3 Arsen Shnurkov 2020-10-25 08:27:24 UTC
Also it is used for testing mono itself -
https://github.com/mono/mono/blob/7fe2472b34a04a4e2ab63b962f7ade1b955d6bc5/mcs/tests/test-xml-051.cs#L2
Comment 4 Sam James archtester gentoo-dev Security 2020-10-25 17:56:48 UTC
(In reply to Arsen Shnurkov from comment #3)
> Also it is used for testing mono itself -
> https://github.com/mono/mono/blob/7fe2472b34a04a4e2ab63b962f7ade1b955d6bc5/
> mcs/tests/test-xml-051.cs#L2

This doesn't fix that the package is unmaintained right now in Gentoo, unfortunately. I did look at bumping some of these and I ended up running into issues with them not respecting multilib. I think the whole .NET thing needs a reboot like OCaml had.
Comment 5 Arsen Shnurkov 2020-10-26 05:04:46 UTC
I think that it's not easy to support multilib in dotnet, because that require patching the mono runtime (to understand different library loading locations)
https://bugs.gentoo.org/751265
Comment 6 Arsen Shnurkov 2020-10-26 09:06:39 UTC
I am looking into source code:
https://github.com/gentoo/gentoo/blob/master/dev-dotnet/log4net/log4net-1.2.11.ebuild#L40-L41
and don't see where is ${EPREFIX} in symlink locations.
Comment 7 Arsen Shnurkov 2020-10-26 09:14:08 UTC
Everything is ok, dosym does that for the second argument automatically,
and the first argument is relarive path.

«${ED} is prepended automatically to the install location.»
https://devmanual.gentoo.org/function-reference/install-functions/

${ED} =	Shorthand for ${D%/}${EPREFIX}/. 
${D} = Path to the temporary install directory. For example: "${PORTAGE_BUILDDIR}/image". 
https://devmanual.gentoo.org/ebuild-writing/variables/index.html
Comment 8 Arsen Shnurkov 2020-10-26 19:46:49 UTC
>>> Compiling source in /var/tmp/portage/dev-dotnet/log4net-2.0.12/work/log4net-2.0.12 ...
src/log4net/Appender/AdoNetAppender.cs(620,10): error CS1525: Unexpected symbol `StringWriter', expecting `('
src/log4net/Layout/XmlLayoutBase.cs(207,9): error CS1525: Unexpected symbol `XmlTextWriter', expecting `('
src/log4net/Layout/LayoutSkeleton.cs(152,9): error CS1525: Unexpected symbol `StringWriter', expecting `('
src/log4net/Layout/Layout2RawLayoutAdapter.cs(86,9): error CS1525: Unexpected symbol `StringWriter', expecting `('
src/log4net/Util/TypeConverters/ConverterRegistry.cs(222,19): error CS1644: Feature `pattern matching' cannot be used because it is not part of the C# 7.0 language specification
src/log4net/Util/PatternString.cs(470,9): error CS1525: Unexpected symbol `StringWriter', expecting `('
src/log4net/ObjectRenderer/RendererMap.cs(97,9): error CS1525: Unexpected symbol `StringWriter', expecting `('
src/log4net/Core/LoggingEvent.cs(917,31): error CS1519: Unexpected symbol `=' in class, struct, or interface member declaration
src/log4net/Core/LoggingEvent.cs(917,33): error CS1520: Class, struct, or interface method must have a return type
src/log4net/Core/LoggingEvent.cs(917,56): error CS1525: Unexpected symbol `?', expecting `:', `;', `{', or `=>'
src/log4net/Config/XmlConfigurator.cs(653,13): error CS1525: Unexpected symbol `WebResponse', expecting `('
src/log4net/Config/XmlConfigurator.cs(657,14): error CS1525: Unexpected symbol `var', expecting `('
src/log4net/Config/XmlConfigurator.cs(738,11): error CS1525: Unexpected symbol `XmlValidatingReader', expecting `('
Compilation failed: 13 error(s), 0 warnings
Comment 9 Arsen Shnurkov 2020-10-26 20:09:15 UTC
error CS1644: Feature `pattern matching' cannot be used because it is not part of the C# 7.2 language specification

Feature `pattern matching'
https://docs.microsoft.com/en-us/dotnet/csharp/pattern-matching

https://docs.microsoft.com/en-us/dotnet/csharp/language-reference/compiler-options/langversion-compiler-option

error CS1617: Invalid -langversion option `8.0'. It must be `ISO-1', `ISO-2', Default, Latest or value in range 1 to 7.2
Comment 10 Arsen Shnurkov 2020-10-26 20:38:03 UTC
https://docs.microsoft.com/en-us/dotnet/csharp/language-reference/configure-language-version

.NET Framework 	=> C# 7.3
.NET Core 3.x => C# 8.0
.NET 5.x => C# 9.0
Comment 11 Arsen Shnurkov 2020-10-26 20:39:50 UTC
# mcs -langversion:?
error CS1617: Invalid -langversion option `?'. It must be `ISO-1', `ISO-2', Default, Latest or value in range 1 to 7.2

# csc -langversion:?
Supported language versions:
default
1
2
3
4
5
6
7.0
7.1
7.2
7.3
8.0 (default)
latestmajor
preview
latest
Comment 12 Arsen Shnurkov 2020-10-26 20:43:44 UTC
src/log4net.Tests/Filter/FilterTest.cs(30,7): error CS0246: The type or namespace name 'NUnit' could not be found
Comment 13 Arsen Shnurkov 2020-10-26 21:54:22 UTC
version bump complete:
https://github.com/ArsenShnurkov/shnurise/tree/master/dev-dotnet/log4net
Comment 14 Arsen Shnurkov 2020-10-26 21:59:39 UTC
By the way, there already was version for EAPI-6 -- http://gpo.zugaina.org/AJAX/Ebuild/20810581/View
Comment 15 Larry the Git Cow gentoo-dev 2020-11-22 14:54:55 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=e7c2bcaa05065b4502abc500f56225b18e78aafb

commit e7c2bcaa05065b4502abc500f56225b18e78aafb
Author:     David Seifert <soap@gentoo.org>
AuthorDate: 2020-11-22 14:54:21 +0000
Commit:     David Seifert <soap@gentoo.org>
CommitDate: 2020-11-22 14:54:21 +0000

    dev-dotnet/log4net: Remove last-rited package
    
    Closes: https://bugs.gentoo.org/722256
    Closes: https://bugs.gentoo.org/740990
    Signed-off-by: David Seifert <soap@gentoo.org>

 dev-dotnet/log4net/Manifest               |  2 --
 dev-dotnet/log4net/files/log4net.pc.in-r1 |  8 ------
 dev-dotnet/log4net/log4net-1.2.11.ebuild  | 44 -------------------------------
 dev-dotnet/log4net/metadata.xml           |  8 ------
 profiles/package.mask                     |  6 -----
 5 files changed, 68 deletions(-)